#include <formatio.h>
#include <ansi_c.h>
#include <tcpsupp.h>
#include <cvirte.h>		
#include <userint.h>
#include "client.h"

static int panelHandle;
unsigned int veza;
int connected;

int ClientTCP (unsigned handle, int event, int error,void *callbackData);
double uzorak;


unsigned int samplecount;

double suma;
double suma_kvadrata;
double srednja;
double efektivna;
static char file_name[MAX_PATHNAME_LEN]; 
int filePokazivac;



int main (int argc, char *argv[])
   {
   if (InitCVIRTE (0, argv, 0) == 0)
		return -1;	/* out of memory */
	if ((panelHandle = LoadPanel (0, "client.uir", PANEL)) < 0)
		return -1;
	DisplayPanel (panelHandle);
	RunUserInterface ();
	DiscardPanel (panelHandle);
	return 0;
}

int CVICALLBACK start (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
   {
   char tempBuf[256];
   char portNumStr[32];
   int  portNum;
   switch (event)
      {
	  case EVENT_COMMIT:
	     {
		 PromptPopup ("Ime servera?",
                 "Ime racunara na kojem radi serverska "
                 "aplikacija.\n\n(na primer: abc.xyz.com ili xxx.xxx.xxx.xxx)",
                 tempBuf, 255);

         /* Unos broja porta na serveru */
         PromptPopup ("Broj porta?",
                 "Ukucaj broj porta koji koristi "
                 "serverska aplikacija.\n\n(na primer: 10000)",
                 portNumStr, 31);
         portNum = atoi (portNumStr); //string broja porta prebacuje se u broj
		 FileSelectPopup ("", "*.acq", "*.acq","Ime datoteke", VAL_OK_BUTTON, 0, 1, 1,1, file_name); 
         /* Povezivanje sa TCP serverom... */
         if (ConnectToTCPServer (&veza, portNum, tempBuf, ClientTCP,NULL, 5000) < 0)
		    {
			MessagePopup("TCP Client", "Povezivanje sa serverom NIJE uspelo !");
			}
         else
            {
			filePokazivac = OpenFile (file_name, VAL_READ_WRITE, VAL_TRUNCATE, VAL_ASCII);           
			connected = 1;
            /* povezivanje uspesno, skupljanje informacija */
            SetCtrlVal (panelHandle, PANEL_CONNECTED, 1);
            GetTCPHostAddr (tempBuf, 256);
	        SetCtrlVal(panelHandle,PANEL_CLIENT_ADDRESS,tempBuf);
	  
	        GetTCPHostName (tempBuf, 256);
	        SetCtrlVal(panelHandle,PANEL_CLIENT_NAME,tempBuf);
	  
	        GetTCPPeerAddr (veza, tempBuf, 256);
	        SetCtrlVal(panelHandle,PANEL_SERVER_ADDRESS,tempBuf);
            GetTCPPeerName (veza, tempBuf, 256);
	        SetCtrlVal(panelHandle,PANEL_SERVER_NAME,tempBuf);
			SetCtrlAttribute (panelHandle, PANEL_START, ATTR_DIMMED, 1);
			SetCtrlAttribute (panelHandle, PANEL_STOP, ATTR_DIMMED, 0);
			samplecount=0;
		    suma=0;
		    suma_kvadrata=0;
			ClearStripChart (panelHandle, PANEL_SIGNAL);
			}
		 break;
      }	 }
   return 0;
   }

int CVICALLBACK stop (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
   {
   switch (event)
      {
	  case EVENT_COMMIT:
	     DisconnectFromTCPServer (veza);
		 CloseFile (filePokazivac);
		 connected=0;
		 SetCtrlVal (panelHandle, PANEL_CONNECTED, 0);
		 SetCtrlVal (panelHandle, PANEL_SERVER_ADDRESS, "");
		 SetCtrlVal (panelHandle, PANEL_SERVER_NAME, "");
		 SetCtrlVal (panelHandle, PANEL_CLIENT_ADDRESS, "");
		 SetCtrlVal (panelHandle, PANEL_CLIENT_NAME, "");
		 SetCtrlAttribute (panelHandle, PANEL_START, ATTR_DIMMED, 0);
		 SetCtrlAttribute (panelHandle, PANEL_STOP, ATTR_DIMMED, 1);
		 break;
   	  }
   return 0;
   }

int CVICALLBACK izlaz (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
   {
   switch (event)
      {
	  case EVENT_COMMIT:
		 {
		 if (connected)
		    {
		    DisconnectFromTCPServer (veza);     
		    CloseFile (filePokazivac);          	
		    }
		 QuitUserInterface (0);
		 break;
      }  }
   return 0;
   }

int ClientTCP (unsigned handle, int event, int error,void *callbackData)                                
   {                                                                               
   char receiveBuf[256] = {0};                                                 
   int  dataSize         = sizeof (receiveBuf) - 1;
   switch (event)                                                              
      {                                                                       
      case TCP_DATAREADY:                                                     
         {
		 if ((dataSize = ClientTCPRead (veza, receiveBuf,dataSize, 1000))< 0)                                                            
            {                                                               
            MessagePopup("","greska");
            }                                                               
         else                                                                
            {
			uzorak = atof(receiveBuf);
			WriteFile (filePokazivac, receiveBuf, 5);                                                                                                         
			PlotStripChartPoint (panelHandle, PANEL_SIGNAL, uzorak);
			suma+=uzorak;                                                                                                                          
			suma_kvadrata+=(uzorak*uzorak) ;                                                                                                       
			samplecount++;                                                                                                                         
			srednja=suma/(double)samplecount;
			SetCtrlVal(panelHandle, PANEL_SREDNJA,srednja);                                                 
			efektivna=suma_kvadrata/(double)samplecount;                                                                                     
			efektivna=sqrt(efektivna);                                                                                                             
			SetCtrlVal(panelHandle, PANEL_EFEKTIVNA,efektivna);   
            }                                                               
         break;
	     }
      case TCP_DISCONNECT:
         {
		 MessagePopup ("TCP Client", "Server je zatvorio vezu!");       
         connected = 0;
		 SetCtrlVal (panelHandle, PANEL_CONNECTED, 0);
		 CloseFile (filePokazivac);
		 SetCtrlVal (panelHandle, PANEL_SERVER_ADDRESS, "");                                 
		 SetCtrlVal (panelHandle, PANEL_SERVER_NAME, "");                                    
		 SetCtrlVal (panelHandle, PANEL_CLIENT_ADDRESS, "");                                 
		 SetCtrlVal (panelHandle, PANEL_CLIENT_NAME, "");                                    
		 SetCtrlAttribute (panelHandle, PANEL_START, ATTR_DIMMED, 0);                        
		 SetCtrlAttribute (panelHandle, PANEL_STOP, ATTR_DIMMED, 1);                         
         break;                                                              
      }  }                                                                         
   return 0;                                                                   
   }
